//     ========================== Navigator.cpp =============================
//     **********************************************************************
//     Author: Yeremeyev Dmitriy Vladimirovich *** mailto:edvmail@mail.ru
//     Last update : 04.01.2010
//     **********************************************************************

#include "Navigator.h"
#include <windows.h>

#define cCmdPauseTime 1000 //    

NAVIGATOR_API TCmdArray* gpCmdArray;         //   
NAVIGATOR_API bool gNovaGateMode  = false;   //    ""
NAVIGATOR_API ushort gCheckpointCounter = 0; //    
NAVIGATOR_API int gWayIdx = 0;               //  

TNavigateData gNvg;             //   
HANDLE hCmdExchangeSection = 0; //      

//   
NAVIGATOR_API void StartNavigateMode(bool aNovaGateMode)
{
	gNovaGateMode = aNovaGateMode;

	if(gpCmdArray) {
		memset(gpCmdArray, 0, sizeof(TCmdArray));
		return;
	}
	
	//   
	hCmdExchangeSection = CreateFileMapping(INVALID_HANDLE_VALUE,
							  NULL, PAGE_READWRITE, 0, sizeof(TCmdArray), "RobotCmdExchange");
	TCmdArray* pCmdArray = (TCmdArray*) MapViewOfFile(hCmdExchangeSection,FILE_MAP_ALL_ACCESS,0,0,sizeof(TCmdArray));
	//     
	memset(&gNvg, 0, sizeof(TNavigateData));
	pCmdArray->Cmd[cmFIRE]  = true;
	Sleep(cCmdPauseTime);
	pCmdArray->Cmd[cmPOWER] = true;
	Sleep(cCmdPauseTime);
	pCmdArray->Cmd[cmFIRE]  = false;
	pCmdArray->Cmd[cmPOWER] = false;
	Sleep(cCmdPauseTime);
	pCmdArray->Cmd[cmFIRE] = true;
	Sleep(cCmdPauseTime/2);
	pCmdArray->Cmd[cmFIRE] = false;
	gpCmdArray = pCmdArray;
}

//   
NAVIGATOR_API void FinishNavigateMode()
{
	gNovaGateMode = false;
	//      
	if(gpCmdArray) {
		TCmdArray* pCmdArray = gpCmdArray; gpCmdArray = NULL;
		memset(pCmdArray, 0, sizeof(TCmdArray));
		pCmdArray->Cmd[cmPOWER] = true;
		Sleep(cCmdPauseTime);
		pCmdArray->Cmd[cmPOWER] = false;			
		UnmapViewOfFile(pCmdArray);
	}
	if(hCmdExchangeSection) { CloseHandle(hCmdExchangeSection); }
}

//    
void TurnBody(ushort aCounter, bool aTurnLeft = true)
{
	bool* pTurnCmd;
	
	if(aTurnLeft) {
		pTurnCmd = &gpCmdArray->Cmd[cmLEFT];
		gpCmdArray->Cmd[cmRIGHT] = false;
	} else {
		pTurnCmd = &gpCmdArray->Cmd[cmRIGHT];
		gpCmdArray->Cmd[cmLEFT] = false;
	}
	
	//    
	if(aCounter & 0x08) {
		if(aCounter & 0x04) {
			gpCmdArray->Cmd[cmFORWARD] = true;
			gpCmdArray->Cmd[cmBACKWARDS] = false;
		} else {
			gpCmdArray->Cmd[cmFORWARD] = false;
			gpCmdArray->Cmd[cmBACKWARDS] = true;
		}
		*pTurnCmd = true;
	} else {
		//  ()
		*pTurnCmd = false;
		gpCmdArray->Cmd[cmFORWARD] = false;
		gpCmdArray->Cmd[cmBACKWARDS] = false;
	}
}

//    
void RandomMotion()
{
	if(!(rand()%8)) {
		//   ()    
		gpCmdArray->Cmd[cmLEFT] = true;
		gpCmdArray->Cmd[cmFORWARD] = true;
	} else {
		if(!(rand()%8)) {
			//   ()    
			gpCmdArray->Cmd[cmRIGHT] = true;
			gpCmdArray->Cmd[cmBACKWARDS] = true;
		} else {
			gpCmdArray->Cmd[cmLEFT] = false;
			gpCmdArray->Cmd[cmRIGHT] = false;
			gpCmdArray->Cmd[cmFORWARD] = false;
			gpCmdArray->Cmd[cmBACKWARDS] = false;
		}
	}
}

//   
NAVIGATOR_API void Navigate(IplImage* apGray, IplImage* apScreen, TRcgObj* apRcgObj,
							TSetCheckpointFunc SetCheckpoint, TLogMessageFunc LogMessage) {

	static ushort PhaseCounter = 0; //  
	static bool   TurnLeft = true;  //   

	if(gpCmdArray) {
		if(!gNovaGateMode) {
			//     
			bool MvFrw = gpCmdArray->Cmd[cmFORWARD];
			bool MvBkw = gpCmdArray->Cmd[cmBACKWARDS];
			bool MvLft = gpCmdArray->Cmd[cmLEFT];
			bool MvRht = gpCmdArray->Cmd[cmRIGHT];
			bool TrLft = gpCmdArray->Cmd[cmTURRET_LEFT];
			bool TrRht = gpCmdArray->Cmd[cmTURRET_RIGHT];
			//    
			memset(gpCmdArray, 0, sizeof(TCmdArray));
			//     ?
			if(apRcgObj->ObjTotal) {// 
				CvRect ObjRect = apRcgObj->ObjRect[0];
				long ObjIdxMax = -1;
				//     
				for(int i=0; i<apRcgObj->ObjTotal; i++) {
					if(ObjIdxMax < apRcgObj->ObjIdx[i]) {
						ObjIdxMax = apRcgObj->ObjIdx[i];
						ObjRect = apRcgObj->ObjRect[i];
					}
				}
				//        
				double ScrBase = MIN(apGray->width, apGray->height);
				double ObjBase = MAX(ObjRect.width, ObjRect.height);
				//        
				double ObjZoom = ObjBase/ScrBase;
				//         
				int cXs = apGray->width>>1;
				int cXo = ObjRect.x + (ObjRect.width>>1);
				int cXd = cXs - cXo;
				//     (  )?
				if(ObjZoom > 0.6  || (ObjZoom > 0.57 && MvBkw)) {// 
					//  
					gpCmdArray->Cmd[cmBACKWARDS] = true;
				}

				//     (  )?
				if(ObjZoom < 0.37 || (ObjZoom < 0.42 && MvFrw)) {// 
					//  
					gpCmdArray->Cmd[cmFORWARD]   = true;
				}

				double CentralRate = fabs(double(cXd))/double(cXs);

				//     ?
				if(cXd > 40) {// 
					//   ()    
					if((!MvLft || CentralRate > 0.33) && gNvg.TurretBalance > 0) {
						gpCmdArray->Cmd[cmLEFT] = true;
					}
					//   
					if(!TrLft) {
						gpCmdArray->Cmd[cmTURRET_LEFT] = true;
						gNvg.TurretBalance++;
					}
				}
				//     ?
				if(cXd < -40) {
					//   ()    
					if((!MvRht || CentralRate > 0.33) && gNvg.TurretBalance < 0) {
						gpCmdArray->Cmd[cmRIGHT] = true;
					}
					//   
					if(!TrRht) {
						gpCmdArray->Cmd[cmTURRET_RIGHT] = true;
						gNvg.TurretBalance--;
					}
				}
				gNvg.MotionSwitch = 7;
			} else {//     
				//   ?
				if(!apRcgObj->CheckpointFound) {// 
					//   ""?
					if(apRcgObj->GateHorizon) {// 
						//     ?
						if(apRcgObj->GateHorizon > 0.09) {// 
							TurnLeft = true;
							//   ()    
							if((!MvLft || fabs(apRcgObj->GateHorizon) > 0.195) && gNvg.TurretBalance > 0) {
								gpCmdArray->Cmd[cmLEFT] = true;
							}
							//   
							if(!TrLft) {
								gpCmdArray->Cmd[cmTURRET_LEFT] = true;
								gNvg.TurretBalance++;
							}
						}
						//     ?
						if(apRcgObj->GateHorizon < -0.09) {
							TurnLeft = false;
							//   ()    
							if((!MvRht || fabs(apRcgObj->GateHorizon) > 0.195) && gNvg.TurretBalance < 0) {
								gpCmdArray->Cmd[cmRIGHT] = true;
							}
							//   
							if(!TrRht) {
								gpCmdArray->Cmd[cmTURRET_RIGHT] = true;
								gNvg.TurretBalance--;
							}
						}
						//  
						gpCmdArray->Cmd[cmFORWARD] = true;
					} else {
						//    
						if(PhaseCounter & 0x30) {
							//    
							RandomMotion();
						} else {
							//    
							TurnBody(PhaseCounter, TurnLeft);
						}
						
						//  
						if(gNvg.TurretBalance) {
							if(gNvg.MotionSwitch) {
								if(gNvg.TurretBalance > 0) {
									gpCmdArray->Cmd[cmLEFT] = true;
								} else {
									gpCmdArray->Cmd[cmRIGHT] = true;
								}
								//  -,    
								if(gNvg.MotionSwitch & 2) {
									if(gNvg.MotionSwitch > 3) {
										gpCmdArray->Cmd[cmFORWARD]   = true;
										gpCmdArray->Cmd[cmBACKWARDS] = false;
									} else {
										gpCmdArray->Cmd[cmFORWARD]   = false;
										gpCmdArray->Cmd[cmBACKWARDS] = true;
									}
								} else {
									gpCmdArray->Cmd[cmFORWARD]   = false;
									gpCmdArray->Cmd[cmBACKWARDS] = false;
								}
								gNvg.MotionSwitch--;
							} else {
								gpCmdArray->Cmd[cmLEFT]  = false;
								gpCmdArray->Cmd[cmRIGHT] = false;
							}
							//  
							if(gNvg.TurretBalance > 0) {
								gpCmdArray->Cmd[cmTURRET_RIGHT] = true;
								gNvg.TurretBalance--;
							} else {
								gpCmdArray->Cmd[cmTURRET_LEFT] = true;
								gNvg.TurretBalance++;
							}
						}
					}
				}
			}
		} else {//   
			if(gCheckpointCounter) {
				gCheckpointCounter--;

				//    
				TurnBody(gCheckpointCounter);
				if(!(gCheckpointCounter & 0x0F)) {
					//   
					SetCheckpoint(gWayIdx+1, 0xFFFF);
				}
			} else {
				if(!(PhaseCounter & 0x07)) {
					//   
					SetCheckpoint(0, 0xFFFF);
				}
			}
		}

		//   
		CvScalar bColor = (gNovaGateMode)?cvScalar(0,0,255):cvScalar(0,255,0);
		cvRectangle(apScreen, cvPoint(10, 30), cvPoint(30, 50),
					bColor, gpCmdArray->Cmd[cmLEFT]?CV_FILLED:2,8,0);

		cvRectangle(apScreen, cvPoint(40, 30), cvPoint(60, 50),
					bColor, gpCmdArray->Cmd[cmBACKWARDS]?CV_FILLED:2,8,0);

		cvRectangle(apScreen, cvPoint(70, 30), cvPoint(90, 50),
					bColor, gpCmdArray->Cmd[cmRIGHT]?CV_FILLED:2,8,0);

		cvRectangle(apScreen, cvPoint(40, 60), cvPoint(60, 80),
					bColor, gpCmdArray->Cmd[cmFORWARD]?CV_FILLED:2,8,0);

		cvRectangle(apScreen, cvPoint(10, 110), cvPoint(30, 130),
					bColor, gpCmdArray->Cmd[cmTURRET_LEFT]?CV_FILLED:2,8,0);

		cvRectangle(apScreen, cvPoint(40, 110), cvPoint(60, 130),
					bColor, gpCmdArray->Cmd[cmFIRE]?CV_FILLED:2,8,0);

		cvRectangle(apScreen, cvPoint(70, 110), cvPoint(90, 130),
					bColor, gpCmdArray->Cmd[cmTURRET_RIGHT]?CV_FILLED:2,8,0);
	}
	PhaseCounter--;
}


