//     ========================= Russification.cpp ==========================
//     **********************************************************************
//     Author: Yeremeyev Dmitriy Vladimirovich *** mailto:edvmail@mail.ru
//     Last update : 02.01.2010
//     **********************************************************************

#pragma warning (disable:4996) // This function or variable may be unsafe

#include "Russification.h"
#include <string.h>
#include <stdio.h>

//   
struct TRuStrTable {
	long  Sum;   //     ( )
	wxChar* Str; //  
};

//      
#define StrRuTableTotal 83
//  
static TRuStrTable RuStrTable[StrRuTableTotal] = {
	{0x00000935, _T("  ")},
	{0x00000bfb, _T("   ")},
	{0x000020e8, _T("   ...\n")
	             _T(",  web-   .")},
	{0x000004a7, _T("&")},
	{0x00000377, _T("&")},
	{0x000001af, _T("&")},
	{0x00000a72, _T("&   ()\tCtrl-S")},
	{0x000006c6, _T("& \tCtrl-L")},
	{0x000008d3, _T("&  \tAlt-S")},
	{0x00000a71, _T("&  \tCtrl-T")},
	{0x00000691, _T("&   AVI \tAlt-D")},
	{0x000006bf, _T("& \tAlt-N")},
	{0x000006de, _T("&  \"\"\tAlt-G")},
	{0x000008b2, _T("&   \tCtrl-F")},
	{0x00000993, _T("&   \tCtrl-C")},
	{0x000001b5, _T("&   ")},
	{0x000001a6, _T("&   ")},
	{0x0000036f, _T("&\tAlt-X")},
	{0x000005a3, _T("&  ")},
	{0x000005ab, _T("&  ")},
	{0x000002a1, _T("& \tF1")},
	{0x00000400, _T("& ")},
	{0x0000134f, _T("      ")},
	{0x0000080a, _T("    ")},
	{0x000007fb, _T("    ")},
	{0x00000e3e, _T("    ")},
	{0x00000a03, _T("   ")},
	{0x00000a0b, _T("   ")},
	{0x00000d35, _T("    ")},
	{0x00000f09, _T("     ")},
	{0x00000489, _T(" ")},
	{0x000006b7, _T("  ")},
	{0x0000157e, _T("       %s   ?")},
	{0x00001a4e, _T("  . ,   ,   .\n")},
	{0x000009fa, _T("  :\n")},
	{0x00001044, _T(" : \"%s\", : %ux%u .")},
	{0x00000cef, _T("    : %s")},
	{0x00000a80, _T("  .... %-7lu")},
	{0x00000901, _T("  ................ %ux%u")},
	{0x000009b4, _T("  ....... %-7u")},
	{0x000009f1, _T("  ........... %-7lu")},
	{0x00000a37, _T("   .......... %-7I64u")},
	{0x00000915, _T(" / ........ %-7I64u")},
	{0x00001306, _T("       ")},
	{0x00001738, _T("        AVM.\n")},
	{0x00001b9a, _T("            .\n")},
	{0x00002109, _T("   ,        AVM.\n")},
	{0x000018b2, _T("     AVM ")},
	{0x00003c06, _T("     ,      (AVM)  .\n")
				 _T("           %s,    .\n\n")
	             _T("  ?")},
	{0x00000b60, _T("   .")},
	{0x000010b3, _T("\n      : \"%s\".")},
	{0x00000fdf, _T(",     .\n")},
	{0x00001de6, _T("  .   \"%s\"      .\n")},
	{0x00000656, _T("  ")},
	{0x00001387, _T("      .\n")},
	{0x00000827, _T("  ")},
	{0x00001720, _T("       %s   ?")},
	{0x00000996, _T("   .\n")},
	{0x00000f16, _T("    (: %s).\n")},
	{0x00000c66, _T("     .\n")},
	{0x00001226, _T(" %s   (  ).")},
	{0x000002f7, _T("!")},
	{0x0000365a, _T("     (EOT: %f).\n")
	             _T("       .\n\n")
	             _T("  ?")},
	{0x000007d3, _T("  ")},
	{0x00001663, _T("   (RobotController.exe)  .")},
	{0x000009ca, _T("  ")},
	{0x00000682, _T(": \"%s\"   .")},
	{0x000009bb, _T("  ")},
	{0x00000806, _T(", .    ...")},
	{0x0000090c, _T("  :")},
	{0x000003ca, _T(" ")},
	{0x00000dec, _T("  : %s,  .")},
	{0x00000574, _T(" ")},
	{0x00000836, _T("  :")},
	{0x00000883, _T("  \"\"\tAlt-C")},
	{0x000006a0, _T("   \"\"")},
	{0x0000101b, _T("     ?")},

	{0x00000c1a, _T("   ")},
	{0x00002289, _T("       .\n\n")
	             _T("    320x240 ?")},
	{0x00000754, _T("   ")},
	{0x00000539, _T("  ")}
};

//    
inline long GetSrtSum(wxChar* apStr) {
	long Sum = 0;
	
#ifdef _UNICODE
	long StrLen = wcslen(apStr);
#else
	long StrLen = strlen(apStr);
#endif

	for(int i=0; i<StrLen; i++) { Sum += apStr[i]; }
	return Sum;
}

//  
wxString MultilingualSupport(wxChar* apText) {
	long StrSum = GetSrtSum(apText);
	//    
	for(int i=0; i<StrRuTableTotal; i++) {
		if(RuStrTable[i].Sum == StrSum) {
			return RuStrTable[i].Str;
		}
	}

	//     (  )
	wxString Text = apText;
	FILE* f = fopen("translate_it.txt","a");
	fprintf(f,"0x%8.8x: %s\n", StrSum, Text.ToAscii());
	fprintf(f,"<=========================>\n");
	fclose(f);

	return Text;
}